# Save/Unsave Domain POST /api/v1/qllm/save-domain/ Content-Type: application/json Provides endpoints to save, unsave, and list saved domains for the authenticated user. GET: List all saved domains. POST: Save a domain to user's collection. DELETE: Remove a domain from user's saved collection. Reference: https://docs.aisquare.studio/api-reference/ai-square-studio-api/qllm/save-domain-list ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: AISquare Studio API version: 1.0.0 paths: /api/v1/qllm/save-domain/: post: operationId: save-domain-create summary: Save/Unsave Domain description: >- Provides endpoints to save, unsave, and list saved domains for the authenticated user. GET: List all saved domains. POST: Save a domain to user's collection. DELETE: Remove a domain from user's saved collection. tags: - subpackage_qllm responses: '200': description: List of saved domains content: application/json: schema: $ref: '#/components/schemas/DomainInfo' '400': description: Invalid input content: application/json: schema: description: Any type '401': description: Unauthorized content: application/json: schema: description: Any type '404': description: Domain not found content: application/json: schema: description: Any type requestBody: content: application/json: schema: $ref: '#/components/schemas/DomainInfo' components: schemas: UserSimple: type: object properties: id: type: integer username: type: string description: >- Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. email: type: string format: email full_name: type: string first_time_login: type: boolean description: Check if this is the user's first login. theme: type: - string - 'null' is_superuser: type: boolean description: >- Designates that this user has all permissions without explicitly assigning them. is_staff: type: boolean description: Designates whether the user can log into this admin site. is_active: type: boolean description: >- Designates whether this user should be treated as active. Unselect this instead of deleting accounts. is_verified: type: boolean profile_picture: type: string format: uri description: |- Convert ImageFieldFile to URL string for JSON serialization. Args: obj: The model instance being serialized (typically IAMUser) Returns: str | None: The URL of the profile picture, or None if not available required: - id - username - email - first_time_login - profile_picture description: >- Mixin to handle profile_picture serialization for WebSocket compatibility. This mixin adds a SerializerMethodField for profile_picture that converts ImageFieldFile objects to URL strings, making them JSON serializable for WebSocket consumers. The mixin intelligently handles profile pictures from IAMUserDetail by: 1. Accessing the related `details` queryset on the IAMUser model 2. Extracting the ImageFieldFile from the first detail record 3. Converting it to a URL string for JSON serialization Usage: ```python class MyUserSerializer(ProfilePictureMixin, serializers.ModelSerializer): class Meta: model = User fields = ['id', 'username', 'profile_picture', ...] ``` Note: - This mixin expects the model to have a `details` related manager - The related detail should have a `profile_picture` ImageField - Returns None if no profile picture is found or an error occurs title: UserSimple GlobalVisibilityEnum: type: string enum: - public - private - team - org description: |- * `public` - Public * `private` - Private * `team` - Team * `org` - Organization title: GlobalVisibilityEnum GlobalCreationStatusEnum: type: string enum: - not_started - in_progress - completed - failed description: |- * `not_started` - Not Started * `in_progress` - In Progress * `completed` - Completed * `failed` - Failed title: GlobalCreationStatusEnum DomainInfo: type: object properties: id: type: string format: uuid domain_id: type: integer name: type: string theme: type: string summary: type: - string - 'null' description: type: - string - 'null' logo: type: - string - 'null' format: uri description: Logo image for the domain (copied from experience) cover: type: - string - 'null' format: uri description: Cover image for the domain (copied from experience) tags: type: array items: type: string created_by: $ref: '#/components/schemas/UserSimple' category: type: - string - 'null' subcategory: type: - string - 'null' focus_area: type: - string - 'null' visibility: $ref: '#/components/schemas/GlobalVisibilityEnum' is_draft: type: boolean co_creators: type: array items: $ref: '#/components/schemas/UserSimple' creation_status: $ref: '#/components/schemas/GlobalCreationStatusEnum' saved: type: boolean metrics: type: string workspace_id: type: integer publication: type: - object - 'null' additionalProperties: description: Any type required: - id - domain_id - tags - created_by - category - subcategory - co_creators - saved - metrics - workspace_id - publication title: DomainInfo ``` ## SDK Code Examples ```python import requests url = "https://api.example.com/api/v1/qllm/save-domain/" payload = { "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": { "username": "johndoe", "email": "johndoe@example.com" }, "co_creators": [ { "username": "janedoe", "email": "janedoe@example.com" } ] } headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/qllm/save-domain/'; const options = { method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{"id":"3fa85f64-5717-4562-b3fc-2c963f66afa6","created_by":{"username":"johndoe","email":"johndoe@example.com"},"co_creators":[{"username":"janedoe","email":"janedoe@example.com"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/qllm/save-domain/" payload := strings.NewReader("{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/qllm/save-domain/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.example.com/api/v1/qllm/save-domain/") .header("Content-Type", "application/json") .body("{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://api.example.com/api/v1/qllm/save-domain/', [ 'body' => '{ "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": { "username": "johndoe", "email": "johndoe@example.com" }, "co_creators": [ { "username": "janedoe", "email": "janedoe@example.com" } ] }', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/qllm/save-domain/"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [ "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": [ "username": "johndoe", "email": "johndoe@example.com" ], "co_creators": [ [ "username": "janedoe", "email": "janedoe@example.com" ] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/qllm/save-domain/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ```python import requests url = "https://api.example.com/api/v1/qllm/save-domain/" payload = { "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": { "username": "johndoe", "email": "johndoe@example.com" }, "co_creators": [ { "username": "janedoe", "email": "janedoe@example.com" } ] } headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/qllm/save-domain/'; const options = { method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{"id":"3fa85f64-5717-4562-b3fc-2c963f66afa6","created_by":{"username":"johndoe","email":"johndoe@example.com"},"co_creators":[{"username":"janedoe","email":"janedoe@example.com"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/qllm/save-domain/" payload := strings.NewReader("{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/qllm/save-domain/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.example.com/api/v1/qllm/save-domain/") .header("Content-Type", "application/json") .body("{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://api.example.com/api/v1/qllm/save-domain/', [ 'body' => '{ "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": { "username": "johndoe", "email": "johndoe@example.com" }, "co_creators": [ { "username": "janedoe", "email": "janedoe@example.com" } ] }', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/qllm/save-domain/"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [ "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": [ "username": "johndoe", "email": "johndoe@example.com" ], "co_creators": [ [ "username": "janedoe", "email": "janedoe@example.com" ] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/qllm/save-domain/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ```python import requests url = "https://api.example.com/api/v1/qllm/save-domain/" payload = { "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": { "username": "johndoe", "email": "johndoe@example.com" }, "co_creators": [ { "username": "janedoe", "email": "janedoe@example.com" } ] } headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/qllm/save-domain/'; const options = { method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{"id":"3fa85f64-5717-4562-b3fc-2c963f66afa6","created_by":{"username":"johndoe","email":"johndoe@example.com"},"co_creators":[{"username":"janedoe","email":"janedoe@example.com"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/qllm/save-domain/" payload := strings.NewReader("{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/qllm/save-domain/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.example.com/api/v1/qllm/save-domain/") .header("Content-Type", "application/json") .body("{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://api.example.com/api/v1/qllm/save-domain/', [ 'body' => '{ "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": { "username": "johndoe", "email": "johndoe@example.com" }, "co_creators": [ { "username": "janedoe", "email": "janedoe@example.com" } ] }', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/qllm/save-domain/"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n \"created_by\": {\n \"username\": \"johndoe\",\n \"email\": \"johndoe@example.com\"\n },\n \"co_creators\": [\n {\n \"username\": \"janedoe\",\n \"email\": \"janedoe@example.com\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [ "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6", "created_by": [ "username": "johndoe", "email": "johndoe@example.com" ], "co_creators": [ [ "username": "janedoe", "email": "janedoe@example.com" ] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/qllm/save-domain/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```